#ifndef LEVEL_H_
#define LEVEL_H_

#include <SFML/System.hpp>
#include <SFML/Graphics.hpp>
#include <vector>
#include <string>

#include "scene.h"
#include "const.h"

struct Player;
struct Entity;

enum LineType {
	NORMAL,
	BAD
};

struct Line {
	sf::Vector2f a, b;
	LineType type;
};

struct Level {
	int id;
	int width, height;
	sf::Vector2f p1StartPos, p2StartPos;
	std::vector<Line> segments;
	std::vector<sf::Vertex> gridVertices;
};

void createLevel(Level* lvl, int width, int height);

void addSegmentToLevel(Level* lvl, sf::Vector2f start, sf::Vector2f end, LineType type);

void drawLevel(Level* lvl, sf::RenderWindow& window);

void saveLevel(Level* lvl, std::string, std::vector<Entity>* entities, sf::Vector2f* p1Pos, sf::Vector2f* p2Pos);

void loadLevel(Level* lvl, std::string, std::vector<Entity>* entities, sf::Vector2f* p1Pos, sf::Vector2f* p2Pos);


bool getEdgeIntersection(sf::Vector2f v0s0, sf::Vector2f v0s1, sf::Vector2f v1s0,
	sf::Vector2f v1s1, sf::Vector2f* intersection);

bool getEdgeIntersection(sf::Vector2f v0s0, sf::Vector2f v0s1, sf::Vector2f v1s0,
	sf::Vector2f v1s1, sf::Vector2f* intersection, float* tGlobal);

bool entityPlayerVisibility(Player* player, Entity* entity, std::vector<Line> segments, float* dist);

#endif
