#ifndef UTILS_H_
#define UTILS_H_

#include <cmath>

#include <SFML/System.hpp>

inline 
float length(const sf::Vector2f& v) {
  return std::sqrt(v.x * v.x + v.y * v.y);
}

inline
float distance(const sf::Vector2f& a, const sf::Vector2f& b) {
  sf::Vector2f v = b - a;
  return length(v);
}

inline
sf::Vector2f normalize(const sf::Vector2f& v) {
  
  sf::Vector2f v2;
  float lgth = length(v);
  v2 = v / lgth;
  return v2;
}


inline
float dot(const sf::Vector2f& a, const sf::Vector2f& b) {
  return (a.x*b.x + a.y+b.y);
}

#endif
