#ifndef ENTITY_H_
#define ENTITY_H_

#include <iostream>

#include <SFML/Graphics.hpp>
#include <SFML/System.hpp>

#include "moveInfo.h"

#include "level.h"



#define NB_SHAPES_ENTITY 2

struct Player;


struct Entity {
	MoveInfo moveInfo;
	sf::CircleShape shapes[NB_SHAPES_ENTITY];
	float radius;
	bool active;
	Player* lastPlayerTouched;
	int value;
};

void createEntity(Entity* entity, sf::Vector2f pos, float r, sf::Color color, int value = 1);

bool updateEntity(Entity* entity, float dt, std::vector<Line>& segments);

bool intersectEntityWithLevel(Entity* entity, std::vector<Line>& segments, sf::Vector2f lastPos, float dt);

inline
void applyForceEntity(Entity& e0, sf::Vector2f f) {
  e0.moveInfo.acc += f;
}

inline
void displayEntity(sf::RenderWindow& window, Entity* entity) {
  for(int i=0 ; i<NB_SHAPES_ENTITY ; i++)
    window.draw(entity->shapes[i]);
}

#endif
